# -*- coding: cp1252 -*-
# sortieren.py

# Sortieren durch binres Mischen
def sortiere(liste):
    if len(liste)<2:
        return liste
    else:
        linkerAbschnitt=liste[len(liste)//2:]
        rechterAbschnitt=liste[:len(liste)//2]
        return mischeSortierteListen(sortiere(linkerAbschnitt),sortiere(rechterAbschnitt))

def mischeSortierteListen(sortierte1, sortierte2):
    # ganz einfach iterativ
    akku=[]
    i=0
    j=0
    while (i<len(sortierte1))or(j<len(sortierte2)):
        if not (i<len(sortierte1)):
            akku=akku+sortierte2[j:j+1]
            j+=1
        elif not (j<len(sortierte2)):
            akku=akku+sortierte1[i:i+1]
            i+=1
        elif sortierte1[i]>sortierte2[j]:
            akku=akku+sortierte2[j:j+1]
            j+=1
        else:
            akku=akku+sortierte1[i:i+1]
            i+=1
    return akku

ergebnis = sortiere([34,988,236457,35,746,256,82,3,23423,23,452,3,1])
print( ergebnis )

import zufallszahlen
unsortiert=zufallszahlen.zufallszahlen(20,10000)
sortiert=sortiere(unsortiert)
print( unsortiert )
print( sortiert )
